stages:
  - init
  - build
  - deploy

init-master:
  stage: init
  only: 
    - master
  environment: master
  before_script:
    - env
  script:
    - echo "$DOCKERFILE" > Dockerfile
  after_script:
    - echo "Done initialization."
  artifacts:
    expire_in: 1h
    paths:
      - .

build-master:
  stage: build
  only: 
    - master
  environment: master
  image: docker:stable
  before_script:
    - echo "Building image..."
    - docker info
    - ls -la
  script:
    - docker build -t $IMAGE:$TAG .
    - docker push $IMAGE:$TAG
    - docker tag $IMAGE:$TAG $IMAGE:$ENV_TYPE
    - docker push $IMAGE:$ENV_TYPE
    - docker image rm $IMAGE:$TAG
  after_script:
    - echo "Image is ready with name $IMAGE:$TAG and $IMAGE:$ENV_TYPE"

deploy-master:
  stage: deploy
  only: 
    - master
  environment: master
  script:
    - if docker ps -a | grep zainunamal; then 
      docker stop zainunamal; 
      docker rm zainunamal; 
      fi
    - docker run -d 
      --name zainunamal 
      -e TZ=Asia/Jakarta 
      -p 11007:${APP_PORT} 
      ${REPO}/${JOB_NAME}:${TAG} 

  after_script:
    - echo "Deployed."
